#include<glib.h>
#include<stdio.h>
#include<fcntl.h>
#include<signal.h>
#include<sys/socket.h>
#include<sys/types.h>
#include<sys/time.h>
#include<unistd.h>
#include<netdb.h>
#include<netinet/in.h>

#include "chatroom.h"


struct _client{
  gint sd;
  gboolean in_use;
  gchar name[NAME_SIZE];
  gchar buf[BUF_SIZE];
};
typedef struct _client client;
client users[MAX_USERS];

void do_service(gpointer id) {
  gint j;
  char tobuf[BUF_SIZE];
  gint uid = GPOINTER_TO_INT(id);

  while(read(users[uid].sd, users[uid].buf, BUF_SIZE) != -1) {
    sprintf(tobuf, "%s:%s\n", users[uid].name, users[uid].buf);
    for(j= 0; j < MAX_USERS; j++) {
      if(users[j].in_use) {
        write(users[j].sd,tobuf, BUF_SIZE);
        g_print("%s", tobuf);
      }
    }
  }
  users[uid].in_use = FALSE;
  close(users[uid].sd);
}

int main(int argc, char *argv[]) {
  int sd, newsd;
  struct sockaddr_in sin;
  socklen_t slen;
  gint count = 0;
  gint flags;
  gchar buf[BUF_SIZE];
  gint i;
  
  sd = socket(AF_INET, SOCK_STREAM, 0);
  if(sd == -1) {
    g_print("create socket error!\n");
    return -1;
  }

  sin.sin_family = AF_INET;
  sin.sin_port = OURPORT;
  slen = sizeof(struct sockaddr_in);
  
  if(bind(sd, &sin, slen) < 0) {
    g_print("bind erro!\n");
    return -1;
  }

  if(listen(sd, 8) < 0) {
    g_print("listen error!\n");
    return -1;
  }

  for(i = 0; i < MAX_USERS; i++) {
    users[i].in_use = FALSE;
  }

  flags = fcntl(sd, F_GETFL);
  fcntl(sd, F_SETFL, flags&~O_NDELAY);

  while(TRUE) {
    newsd = accept(sd, &sin, &slen);
    if(newsd == -1) {
      g_print("accept error!\n");
      break;
    } else {
      if(count >= MAX_USERS) {
        sprintf(buf, "用户数量过多服务器不能连接。\n");
        write(newsd, buf, BUF_SIZE);
        close(newsd);
      } else {
        flags = fcntl(users[i].sd, F_GETFL);
        fcntl(users[i].sd, F_SETFL, O_NONBLOCK);
        users[count].sd = newsd;
        users[count].in_use = TRUE;
        read(newsd, users[count].name, NAME_SIZE);
        g_thread_new("do_server",
                     (GThreadFunc)do_service,
                     GINT_TO_POINTER(count));
        count++;
      }
    }
  }
  printf("sd is never closed!\n");
  close(sd);

  return 0;
}
